﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GasolineTanker
{
    internal class LongMap : AbstractMap
    {
        private readonly Brush barrierColor = new SolidBrush(Color.Black);
        private readonly Brush roadColor = new SolidBrush(Color.Gray);
        protected override void DrawBarrierPart(Graphics g, int i, int j)
        {
            g.FillRectangle(barrierColor, i * _size_x, j * _size_y, _size_x, _size_y);
        }
        protected override void DrawRoadPart(Graphics g, int i, int j)
        {
            g.FillRectangle(roadColor, i * _size_x, j * _size_y, _size_x, _size_y);
        }
        protected override void GenerateMap()
        {
            _map = new int[100, 100];
            _size_x = (float)_width / _map.GetLength(0);
            _size_y = (float)_height / _map.GetLength(1);
            int counter = 0;
            for (int i = 0; i < _map.GetLength(0); ++i)
            {
                for (int j = 0; j < _map.GetLength(1); ++j)
                {
                    _map[i, j] = _freeRoad;
                }
            }
            while (counter < 5)
            {
                int xStart = _random.Next(0, 100);
                int xEnd = _random.Next(80, 100);

                for (int i = xStart; i <= xEnd; ++i)
                {
                    _map[i, xStart] = _barrier;
                }

                counter++;
            }
        }
    }
}

